require emu-plc, 0.1.0
require emu-motor, 0.1.0


# Set environmental variables
epicsEnvSet("ASYN_PORT",        "GEOBRICK_ASYN")
epicsEnvSet("PMAC_IP", 	        "10.2.76.225") 
# Catnae: 10.10.3.42
epicsEnvSet("PMAC_PORT",        "1025")


# fonctions from TPMAC
# Connection to GEOBRICK, create a asyn port
pmacAsynIPConfigure($(ASYN_PORT), $(PMAC_IP):$(PMAC_PORT))

# s7plcConfigure (PLCname, IPaddr, port, inSize, outSize, bigEndian, recvTimeout, sendIntervall)
s7plcConfigure ("plc", "10.10.2.3", 2000, 40, 6, 1, 1000, 500)

# load PLC database
dbLoadRecords("input.db")
dbLoadRecords("output.db")


# load PMAC (geobrick) database
dbLoadRecords("get_value_pmac.db")
dbLoadRecords("set_value_pmac.db")
dbLoadRecords("console.db")

# communication between PLC and PMAC (Geobrick)
dbLoadRecords("set_bo_PLC.db")
dbLoadRecords("set_bo_pmac.db")


